from sympy import symbols,diff
from sympy.utilities.codegen import codegen
from sympy.abc import x, y, z #import variable for sympy
import sympy

import sys
import pprint
oldhook = sys.displayhook
sys.displayhook = pprint

CC3D_INSTALL = '/home/quasiben/Research/CompuCell/Project_Installs/Install_3.6.0_RAD/'
fileName = 'UserFuncs'

pdeFunc = x**2*sympy.sin(x)+sympy.sin(y)*z*x
doubleDeriv = diff(diff(pdeFunc,y),x)

funcs = [("OneDoubleFunc",-0.01*x),("MyFunc1",-0.01*x+y*0.0),("MyFunc2",0.01*x+y*0.0),\
  ("AdvancedCalc",sympy.sin(x)+sympy.cos(y**2)+2*sympy.pi*z),("pdeFunc",pdeFunc),("DiffPDEFunc",doubleDeriv)] #can simplify with from sympy import *. 

#print funcs
[(c_name, c_code), (h_name, c_header)] = \
	codegen(funcs, "C", fileName, header=False, empty=False)

#print c_name
#print h_name
#print c_code
#print c_header

codegen(funcs, "C", "UserFuncs", header=False, empty=False,to_files=True)

#include <stdio.h>

import os
#tcc -Wall -fPIC -c hello.c; tcc  -shared -Wl hello.o -o hello.so
os.system('tcc -Wall -fPIC -c ' + c_name);
os.system('tcc -shared -Wl ' + fileName +'.o -o ' + fileName + '.so')
print 'copying '+fileName+'.so'+' to '+CC3D_INSTALL+'lib/'
import shutil
shutil.copy2(fileName+'.so',CC3D_INSTALL+'lib/'+fileName+'.so');
